;Defines
#define MyAppName "My Extensibility Ext"
#define MyAppPath "{pf}\MyExtensibilityExt"
#define MyExtention = "C:\Users\Daniel.Vieira\Documents\Visual Studio 2017\Projects\C#\V10\ExtensibilityERP\ExtensibilityERP\bin\Debug\ExtensibilityERP.dll"
#define MyExtentionFileName = "ExtensibilityERP.dll"
#define MyOutputBaseFilename = "ExtensibilityExt_setup"

[Setup]
AppName={#MyAppName}
AppVersion=1.0
OutputBaseFilename={#MyOutputBaseFilename}
WizardStyle=modern
DisableWelcomePage=no
DefaultDirName={#MyAppPath}
DisableDirPage = No
DisableProgramGroupPage=yes
UninstallDisplayIcon={app}\setup.exe
PrivilegesRequired=admin

[Languages]
Name: "portuguese"; MessagesFile: "compiler:Languages\Portuguese.isl"

[Files]
// Extenses a instalar
Source: {#MyExtention}; DestDir: "{app}"; Flags: ignoreversion; AfterInstall: RegisterExtraCloseApplicationsResources('{app}\{#MyExtentionFileName}')

[Code]
var
    UserPage: TInputQueryWizardPage;
    ProductType: TInputOptionWizardPage;
    ExtensionTypePage: TInputOptionWizardPage;

procedure InitializeWizard;
begin

    // Acesso ao ERP.
    UserPage := CreateInputQueryPage(wpWelcome,
    'Informao de acesso ao ERP', '',
    'Indique as suas credenciais de acesso e a empresa, depois clique em seguinte.');
    UserPage.Add('Utilizador:', False);
    UserPage.Add('Palavra Chave:', True);
    UserPage.Add('Empresa:', False);

    // Linha de produto.
    ProductType := CreateInputOptionPage(UserPage.ID,'Linha de produto', '',
    'Indique qual a linha de produto, depois clique em seguinte.',True, False);
    ProductType.Add('Executive');
    ProductType.Add('Professional');

    // Valor selecionado por defeito.
    ProductType.Values[0] := True;

    // Tipo de extenso.
    ExtensionTypePage := CreateInputOptionPage(UserPage.ID,
    'Tipo de Extenso', '','Indique o tipo de extenso, depois clique em seguinte.',True, False);
    ExtensionTypePage.Add('Extenso est disponivel para todas as empresas.');
    ExtensionTypePage.Add('Extenso aplica-se apenas a uma empresa.');

    // Valor selecionado por defeito.
    ExtensionTypePage.Values[1] := True;

    // Grava valores selecionados em memria. 
    UserPage.Values[0] := GetPreviousData('User', ExpandConstant('{sysuserinfoname}'));
    UserPage.Values[2] := GetPreviousData('Company', ExpandConstant('{sysuserinfoorg}'));

end;

procedure RegisterPreviousData(PreviousDataKey: Integer);
var
    UsageMode: String;
begin

    // Carrega os valores selecionados na ultima vz.
    SetPreviousData(PreviousDataKey, 'User', UserPage.Values[0]);
    SetPreviousData(PreviousDataKey, 'Company', UserPage.Values[2]);  

end;

function NextButtonClick(CurPageID: Integer): Boolean;
var
    I: Integer;
begin

    // Validate pages before allowing the user to proceed 
    if CurPageID = UserPage.ID then begin

        if UserPage.Values[0] = '' then begin

            MsgBox('You must enter the user name to proceed.', mbError, MB_OK);
            Result := False;

        end

        if UserPage.Values[2] = '' then begin

            MsgBox('You must enter the company code to proceed.', mbError, MB_OK);
            Result := False;

        end else 
            Result := True;

    end else
        Result := True;

end;

// Registo da exetenso.
procedure RegisterExtraCloseApplicationsResources(FileName: String);
var
    user: String;
    password: String;
    company: String;
    platformType: String;
    communExtension: String;
    ResultCode: Integer;
    erpFolder: String;
    percursoAPL: String;
    platRegValue: String;
    cmdLineParams: String;
    strInstallPath: String;
begin

    if FileName = '' then
        exit;

    // Pasta de instalao
    strInstallPath := ExpandConstant(FileName);

    user := UserPage.Values[0]; 
    password := UserPage.Values[1]; 
    company := UserPage.Values[2];

    if (ProductType.SelectedValueIndex = 0) then begin

        platformType := '0';
        platRegValue := 'SGE100';

    end else begin

        platformType := '1';
        platRegValue := 'SGP100';

    end
  
    case ExtensionTypePage.SelectedValueIndex of
        0: communExtension := '0';
        1: communExtension := '1';
    end;
  
    if RegQueryStringValue(HKLM, 'SOFTWARE\WOW6432Node\PRIMAVERA\'+ platRegValue + '\Default\ADM', 'PERCURSOCONFIG', erpFolder) then begin

        // Qual o tipo de extenso?
        if (communExtension = '1') then begin

            communExtension := 'True';

            if not(DirExists(erpFolder + '\Extensions\' + company)) then 
                CreateDir(erpFolder + '\Extensions\' + company);

        end else begin      

            communExtension := 'False';

            if not(DirExists(erpFolder + '\CommonExtensions\')) then 
                CreateDir(erpFolder + '\CommonExtensions\');

        end;
           
        // Copiar e registar as extenses.
        if RegQueryStringValue(HKLM, 'SOFTWARE\WOW6432Node\PRIMAVERA\'+ platRegValue + '\Default\ADM', 'PERCURSOAPL', percursoAPL) then begin

            if FileExists(percursoAPL + '\RegisterExtension.exe') then begin

                // Parmetros para a linha de commando.
                cmdLineParams:= company + ' ' + user + ' ' + password + ' ' + platformType + ' "' + strInstallPath + '" ' + communExtension;

                // Registo da extenso no ERP
                if Exec(ExpandConstant(percursoAPL + '\RegisterExtension.exe'), cmdLineParams, '', SW_SHOW, ewWaitUntilTerminated, ResultCode) then begin

                    if ResultCode = 0 then begin
                        MsgBox('Registo da extenso concludo com sucesso.', mbInformation, MB_OK);
                    end else begin
                        MsgBox('Erro ao registar a extenso no ERP, deve efectuar o registto manualmente [' + strInstallPath + '].', mbError, MB_OK);
                    end
                    
                end

            end else begin

                MsgBox('No foi possvel determinar a localizao do comando que efetua o registo da extenso, deve regist-la manualmente [' + strInstallPath + '].', mbError, MB_OK);

            end

        end else
            MsgBox('No foi possvel determinar a pasta de instalao do erp.', mbError, MB_OK); 

    end else
        MsgBox('No foi possvel determinar a pasta de instalao das extenses.', mbError, MB_OK); 

end;